'use strict';

function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = !0,
      o = !1;
    try {
      if (i = (t = t.call(r)).next, 0 === l) {
        if (Object(t) !== t) return;
        f = !1;
      } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = !0, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), !0).forEach(function (r) {
      _defineProperty(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var metricsName = {
  FP: "first-paint",
  FCP: "first-contentful-paint",
  LCP: "largest-contentful-paint",
  FID: "first-input-delay",
  CLS: "cumulative-layout-shift",
  NT: "navigation-timing",
  RF: "resource-flow"
};
var metricsStore = /*#__PURE__*/function () {
  function metricsStore() {
    _classCallCheck(this, metricsStore);
    this.state = new Map();
  }
  return _createClass(metricsStore, [{
    key: "set",
    value: function set(key, value) {
      this.state.set(key, value);
    }
  }, {
    key: "add",
    value: function add(key, value) {
      var keyValue = this.state.get(key);
      this.state.set(key, keyValue ? keyValue.concat([value]) : [value]);
    }
  }, {
    key: "get",
    value: function get(key) {
      return this.state.get(key);
    }
  }, {
    key: "has",
    value: function has(key) {
      return this.state.has(key);
    }
  }, {
    key: "clear",
    value: function clear() {
      this.state.clear();
    }
  }, {
    key: "getValues",
    value: function getValues() {
      // Map 转为 对象 返回
      return Object.fromEntries(this.state);
    }
  }]);
}();

function observe(type, handler) {
  new PerformanceObserver(function (entryList) {
    var entries = entryList.getEntries();
    var entry = entries[entries.length - 1];
    console.log("".concat(type), entry);
    handler(entry);
  }).observe({
    type: type,
    buffered: true
  });
}

// export const observe = (type, callback) => {
//   // 类型合规，就返回 observe
//   if (PerformanceObserver.supportedEntryTypes?.includes(type)) {
//     const ob: PerformanceObserver = new PerformanceObserver((l) => l.getEntries().map(callback));

//     ob.observe({ type, buffered: true });
//     return ob;
//   }
//   return undefined;
// };

// function observe(type, handler) {
//   new PerformanceObserver((entryList) => {
//     const entries = entryList.getEntries();
//     const entry = entries[entries.length - 1];
//     console.log(`${type}`, entry);
//     handler(entry);
//   }).observe({ type: type, buffered: true });
// }

var WebVitals = /*#__PURE__*/function () {
  function WebVitals() {
    var _this = this;
    _classCallCheck(this, WebVitals);
    this.metrics = new metricsStore();
    this.initLCP();
    this.initCLS();
    this.initResourceFlow();
    afterLoad(function () {
      _this.initNavigationTiming();
      _this.initFP();
      _this.initFCP();
      _this.initFID();
      _this.perfSendHandler();
    });
  }
  return _createClass(WebVitals, [{
    key: "perfSendHandler",
    value:
    // 性能上报的策略
    function perfSendHandler() {}
  }, {
    key: "initFP",
    value:
    // 初始化 FP 的获取以及返回
    function initFP() {
      var getFP = function getFP() {
        var _performance$getEntri = performance.getEntriesByName("first-paint"),
          _performance$getEntri2 = _slicedToArray(_performance$getEntri, 1),
          entry = _performance$getEntri2[0];
        return entry;
      };
      var entry = getFP();
      var metrics = {
        startTime: entry === null || entry === void 0 ? void 0 : entry.startTime.toFixed(2),
        entry: entry
      };
      this.metrics.set(metricsName.FP, metrics);
    }
  }, {
    key: "initFCP",
    value:
    // 初始化 FCP 的获取以及返回
    function initFCP() {
      var getFCP = function getFCP() {
        var _performance$getEntri3 = performance.getEntriesByName("first-contentful-paint"),
          _performance$getEntri4 = _slicedToArray(_performance$getEntri3, 1),
          entry = _performance$getEntri4[0];
        return entry;
      };
      var entry = getFCP();
      var metrics = {
        startTime: entry === null || entry === void 0 ? void 0 : entry.startTime.toFixed(2),
        entry: entry
      };
      this.metrics.set(metricsName.FCP, metrics);
    }
  }, {
    key: "initLCP",
    value:
    // 初始化 LCP 的获取以及返回
    function initLCP() {
      var _this2 = this;
      var getLCP = function getLCP(entryHandler) {
        return observe("largest-contentful-paint", entryHandler);
      };
      var entryHandler = function entryHandler(entry) {
        var metrics = {
          startTime: entry === null || entry === void 0 ? void 0 : entry.startTime.toFixed(2),
          entry: entry
        };
        _this2.metrics.set(metricsName.LCP, metrics);
      };
      getLCP(entryHandler);
    }
  }, {
    key: "initFID",
    value:
    // 初始化 FID 的获取 及返回
    function initFID() {
      var _this3 = this;
      var getFID = function getFID(entryHandler) {
        return observe("first-input", entryHandler);
      };
      var entryHandler = function entryHandler(entry) {
        var metrics = {
          delay: entry.processingStart - entry.startTime,
          entry: entry
        };
        _this3.metrics.set(metricsName.FID, metrics);
      };
      getFID(entryHandler);
    }
  }, {
    key: "initCLS",
    value:
    // 初始化 CLS 的获取以及返回
    function initCLS() {
      var _this4 = this;
      var getCLS = function getCLS(entryHandler) {
        return observe("layout-shift", entryHandler);
      };
      var clsValue = 0;
      var clsEntries = [];
      var sessionValue = 0;
      var sessionEntries = [];
      var entryHandler = function entryHandler(entry) {
        if (!entry.hadRecentInput) {
          var firstSessionEntry = sessionEntries[0];
          var lastSessionEntry = sessionEntries[sessionEntries.length - 1];

          // 如果条目与上一条目的相隔时间小于 1 秒且
          // 与会话中第一个条目的相隔时间小于 5 秒，那么将条目
          // 包含在当前会话中。否则，开始一个新会话。
          if (sessionValue && entry.startTime - lastSessionEntry.startTime < 1000 && entry.startTime - firstSessionEntry.startTime < 5000) {
            sessionValue += entry.value;
            sessionEntries.push(entry);
          } else {
            sessionValue = entry.value;
            sessionEntries = [entry];
          }

          // 如果当前会话值大于当前 CLS 值，
          // 那么更新 CLS 及其相关条目。
          if (sessionValue > clsValue) {
            clsValue = sessionValue;
            clsEntries = sessionEntries;

            // 记录 CLS 到 Map 里
            var metrics = {
              entry: entry,
              clsValue: clsValue,
              clsEntries: clsEntries
            };
            _this4.metrics.set(metricsName.CLS, metrics);
          }
        }
      };
      getCLS(entryHandler);
    }
  }, {
    key: "initNavigationTiming",
    value:
    // 初始化 NT 的获取以及返回
    function initNavigationTiming() {
      var getNavigationTiming = function getNavigationTiming() {
        var resolveNavigationTiming = function resolveNavigationTiming(entry) {
          var domainLookupStart = entry.domainLookupStart,
            domainLookupEnd = entry.domainLookupEnd,
            connectStart = entry.connectStart,
            connectEnd = entry.connectEnd,
            secureConnectionStart = entry.secureConnectionStart,
            requestStart = entry.requestStart,
            responseStart = entry.responseStart,
            responseEnd = entry.responseEnd,
            domInteractive = entry.domInteractive,
            domContentLoadedEventEnd = entry.domContentLoadedEventEnd,
            loadEventStart = entry.loadEventStart,
            fetchStart = entry.fetchStart;
          return {
            // 关键时间点
            FP: responseEnd - fetchStart,
            TTI: domInteractive - fetchStart,
            DomReady: domContentLoadedEventEnd - fetchStart,
            Load: loadEventStart - fetchStart,
            FirstByte: responseStart - domainLookupStart,
            // 关键时间段
            DNS: domainLookupEnd - domainLookupStart,
            TCP: connectEnd - connectStart,
            SSL: secureConnectionStart ? connectEnd - secureConnectionStart : 0,
            TTFB: responseStart - requestStart,
            Trans: responseEnd - responseStart,
            DomParse: domInteractive - responseEnd,
            Res: loadEventStart - domContentLoadedEventEnd
          };
        };
        var navigation =
        // W3C Level2  PerformanceNavigationTiming
        // 使用了High-Resolution Time，时间精度可以达毫秒的小数点好几位。
        performance.getEntriesByType("navigation").length > 0 ? performance.getEntriesByType("navigation")[0] : performance.timing; // W3C Level1  (目前兼容性高，仍然可使用，未来可能被废弃)。
        return resolveNavigationTiming(navigation);
      };
      var navigationTiming = getNavigationTiming();
      var metrics = navigationTiming;
      this.metrics.set(metricsName.NT, metrics);
    }
  }, {
    key: "initResourceFlow",
    value:
    // 初始化 RF 的获取以及返回
    function initResourceFlow() {
      var _this5 = this;
      var getRF = function getRF(callback) {
        var resource = performance.getEntriesByType("resource");
        var cacheQuantity = 0;
        resource.map(function (item) {
          if (item.duration == 0 && item.transferSize !== 0) cacheQuantity++;
          var data = _objectSpread2(_objectSpread2({}, item), {}, {
            name: item.name,
            //资源地址
            startTime: item.startTime,
            //开始时间
            responseEnd: item.responseEnd,
            //结束时间
            time: item.duration,
            //消耗时间
            initiatorType: item.initiatorType,
            //资源类型
            transferSize: item.transferSize //传输大小
            //请求响应耗时 ttfb = item.responseStart - item.startTime
            //内容下载耗时 tran = item.responseEnd - item.responseStart
            //但是受到跨域资源影响。除非资源设置允许获取timing
          });
          callback(data);
          return data;
        });
        console.log("缓存命中率", (cacheQuantity / resource.length).toFixed(2));
      };
      var getResourceFlow = function getResourceFlow(resourceFlow) {
        var entryHandler = function entryHandler(entry) {
          var name = entry.name,
            transferSize = entry.transferSize,
            initiatorType = entry.initiatorType,
            startTime = entry.startTime,
            responseEnd = entry.responseEnd,
            domainLookupEnd = entry.domainLookupEnd,
            domainLookupStart = entry.domainLookupStart,
            connectStart = entry.connectStart,
            connectEnd = entry.connectEnd,
            secureConnectionStart = entry.secureConnectionStart,
            responseStart = entry.responseStart,
            requestStart = entry.requestStart;
          resourceFlow.push({
            // name 资源地址
            name: name,
            // transferSize 传输大小
            transferSize: transferSize,
            // initiatorType 资源类型
            initiatorType: initiatorType,
            // startTime 开始时间
            startTime: startTime,
            // responseEnd 结束时间
            responseEnd: responseEnd,
            // 贴近 Chrome 的近似分析方案，受到跨域资源影响
            dnsLookup: domainLookupEnd - domainLookupStart,
            initialConnect: connectEnd - connectStart,
            ssl: connectEnd - secureConnectionStart,
            request: responseStart - requestStart,
            ttfb: responseStart - requestStart,
            contentDownload: responseStart - requestStart
          });
        };
        return getRF(entryHandler);
      };
      var resourceFlow = [];
      var resObserve = getResourceFlow(resourceFlow);
      var stopListening = function stopListening() {
        if (resObserve) {
          resObserve.disconnect();
        }
        var metrics = resourceFlow;
        _this5.metrics.set(metricsName.RF, metrics);
      };
      // 当页面 pageshow 触发时，中止
      window.addEventListener("pageshow", stopListening, {
        once: true,
        capture: true
      });
    }
  }]);
}();
var afterLoad = function afterLoad(callback) {
  if (document.readyState === "complete") {
    setTimeout(callback);
  } else {
    window.addEventListener("pageshow", callback, {
      once: true,
      capture: true
    });
  }
};

// import * as monitor from 'art-monitor'
// console.log(monitor.monitor)

var monitor = {
  init: function init() {
    console.log("Monitoring init...");
    // WebVitals
    console.log("WebVitals", new WebVitals());
  }
};

// module.exports = monitor

// monitor.init()

// export function monitor() {
//     console.log('Monitoring data...');
// }

module.exports = monitor;
